;
; PackeTen Inter-Processor Communications interrupt handler routine
; "straight forward copy" from eaglevec.asm
;
    .MODEL    MEMMOD,C
    LOCALS
    %MACS
    .LALL

    extrn    Stktop,Spsave,Sssave,ipc_entpt:proc,doret:proc,eoi:proc

    .CODE
dbase    dw    @Data        ; save loc for ds (must be in code segment)

    public    P10ipc_vec
    label    P10ipc_vec far
    cli
    push    ds        ; save on user stack
    mov    ds,cs:dbase    ; establish interrupt data segment

    mov    Sssave,ss    ; stash user stack context
    mov    Spsave,sp

    mov    ss,cs:dbase
    lea    sp,Stktop

    push    ax        ; save user regs on interrupt stack
    push    bx
    push    cx
    push    dx
    push    bp
    push    si
    push    di
    push    es
    call    eoi
    mov    ax,0        ; arg for service routine
    push    ax
    call    ipc_entpt
    pop    ax
    pop    es
    pop    di
    pop    si
    pop    bp
    pop    dx
    pop    cx
    pop    bx
    pop    ax
    mov    ss,Sssave
    mov    sp,Spsave    ; restore original stack context
    pop    ds
    sti
    iret
    end

